<?
//========================================================================
//       exetype - Change the type of an executable (WINDOWS or CONSOLE)
//       Port of Perl's exetype.
//
//       Author : Eric Colinet <e dot colinet at laposte dot net>
//       Original Author : Jan Dubois <jand at ActiveState dot com>
//       Home : http://wildphp.free.fr/wiki/doku?id=win32std:embeder
//       Original Home : http://jenda.krynicky.cz/perl/GUIscripts.html
//========================================================================

/**
 * Common banner
 */
function banner() {
	echo ucfirst(basename($_SERVER['argv'][0]))." ".(defined('EMBEDED')?'(embeded) ':'').'- Powered by PHP version '.phpversion()."\n";
}

/**
 * Fatal error
 */
function err($txt) {
	banner();
	die("[ERR] ".$txt."\n");
}

/**
 * Usage output
 */
function usage() {
	banner();
	die("Usage: {$argv[0]} exefile [CONSOLE|WINDOWS]\n");
}

/**
 * Info
 */
function info($txt) {
	echo "[INFO] $txt\n";
}

/**
 *  File transformation function
 */
function _f($file, $force=false) { return $force||defined('EMBEDED')?'res:///PHP/'.md5($file):$file; }

/* Check that win32std is loaded */
if( !extension_loaded('win32std') ) err("I need win32std !");

/**
 * [Debug] dump an unpack'ed record
 */
function dump_record($record) {
	foreach($record as $k=>$v) info(sprintf("$k => %x", $v));
}

if( $argc>1 && $argv[1]=='help' )
	usage();

if( $argc != 3 || !in_array($new_format= strtoupper($argv[2]), array('CONSOLE', 'WINDOWS')) ) 
	err("Bad parameters. Try: {$argv[0]} help");

$f= fopen($argv[1], 'r+b');
if( !$f ) err("Can't open '{$argv[1]}'");

$type_record= unpack('Smagic/x58/Loffset', fread($f, 32*4));
if( $type_record['magic'] != 0x5a4d ) err("Not an MSDOS executable file");

if( fseek($f, $type_record['offset'], SEEK_SET) != 0 ) err("seeking error (+{$type_record['offset']})");
$pe_record= unpack('Lmagic/x16/Ssize', fread($f, 24));
if( $pe_record['magic'] != 0x4550 ) err("PE header not found");
if( $pe_record['size'] != 224 ) err("Optional header not in NT32 format");

if( fseek($f, $type_record['offset']+24+68, SEEK_SET) != 0 ) err("seeking error (+{$type_record['offset']})");
if( fwrite($f, pack('S', $new_format=='CONSOLE'?3:2))===false ) err("write error");

fclose($f);

info("'$argv[1]' updated to '$new_format'");
?>